"use strict";

/**
 * 将 base64 转换为 File
 *
 * @param {*} base64 base64数据
 * @param {*} fileName 文件名
 * @return File
 */
function base64ToFile(base64) {
  var fileName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '导出文件';
  var arr = base64.split(',');
  var mime = arr[0].match(/:(.*?);/)[1];
  var bstr = atob(arr[1]);
  var n = bstr.length;
  var u8arr = new Uint8Array(n);

  while (n--) {
    u8arr[n] = bstr.charCodeAt(n);
  }

  return new File([u8arr], fileName, {
    type: mime
  });
}

module.exports = base64ToFile;