"use strict";

/**
 * @desc   自动转换字节单位
 * @param  {Number} bytes
 * @return {String}
 */
function bytesToSize(bytes) {
  if (Object.prototype.toString.call(bytes).slice(8, -1) !== 'Number') {
    return "0 B";
  }

  if (bytes === 0) return "0 B";
  var k = 1024;
  var sizes = ["B", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"];
  var i = Math.floor(Math.log(bytes) / Math.log(k));
  return (bytes / Math.pow(k, i)).toPrecision(3) + " " + sizes[i];
}

module.exports = bytesToSize;