"use strict";

/**
 * 比较版本号
 * @param {*} version1 版本号1
 * @param {*} version2 版本号2
 * @returns
 * 如果version1 > version2，返回1；
 * 如果version1 < version2，返回-1，
 * 其他情况返回0
 */
function compareVersion(version1, version2) {
  var newVersion1 = "".concat(version1).split('.').length < 3 ? "".concat(version1).concat('.0') : "".concat(version1);
  var newVersion2 = "".concat(version2).split('.').length < 3 ? "".concat(version2).concat('.0') : "".concat(version2); // 计算版本号大小,转化大小

  function toNum(a) {
    var c = a.toString().split('.');
    var num_place = ["", "0", "00", "000", "0000"],
        r = num_place.reverse();

    for (var i = 0; i < c.length; i++) {
      var len = c[i].length;
      c[i] = r[len] + c[i];
    }

    return c.join('');
  } // 检测版本号是否需要更新


  function checkPlugin(a, b) {
    var numA = toNum(a);
    var numB = toNum(b);
    return numA > numB ? 1 : numA < numB ? -1 : 0;
  }

  return checkPlugin(newVersion1, newVersion2);
}

module.exports = compareVersion;