"use strict";

/**
 * 获取字符长度，一个汉字算两个
 * @desc   获取字符串字符长度(汉字转换)
 * @param  {String} str
 * @return {Length}
 */
function getStrLength(str) {
  if (Object.prototype.toString.call(str).slice(8, -1) !== 'String') {
    return 0;
  } // 先把中文替换成两个字节的英文，再计算长度


  return str.replace(/[\u0391-\uFFE5]/g, "aa").length;
}

module.exports = getStrLength;