"use strict";

/**
 * @desc   安全 Parse string to JSON
 * @param  {String} str
 * @param  {Object} defaultObj
 * @return {Object}
 */
function safeParseJSON(str, defaultObj) {
  var result;

  try {
    result = JSON.parse(str);
  } catch (err) {
    console.warn("json parse error:", err);
    result = typeof defaultObj === "undefined" ? str : defaultObj;
  }

  return result || defaultObj;
}

module.exports = safeParseJSON;